/**
 * @Author Michael Kirsch
 * @Date 01.12.2014
 * Diese Klasse repräsentiert einen Adventskalender mit 24 Türchen und kann verschiedene Aktionen ausführen
 */

import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

public class Adventskalender extends JFrame implements ActionListener {

    // Hier die globalen Komponenten Deklarieren
    private static final long serialVersionUID = 4088998709397579298L;
    private JButton[] buttons;
    private Container contentPane;

    public Adventskalender() {
	init();
    }

    private void init() {
	this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	this.setTitle("Adventskalender - Weihnachten 2014");
	this.setResizable(false);

	// Hier das Fenster aufbauen
	this.setLayout();
	this.addComponents();
	this.addActionListener();
	this.setSize(400, 600);

	// Am Ende machen
	this.setLocation(getCenterPosition(this));
    }

    /*
     * Fügt ActionListener zu den Komponenten hinzu
     */
    private void addActionListener() {
	for (int i = 0; i < buttons.length; i++) {
	    buttons[i].addActionListener(this);
	}
    }

    /*
     * Fügt Komponenten zur ContentPane oder Komponenten hinzu
     */
    private void addComponents() {

	buttons = new JButton[24];
	for (int i = 0; i < buttons.length; i++) {
	    buttons[i] = new JButton(String.valueOf(i + 1));
	    contentPane.add(buttons[i]);
	}
    }

    /*
     * Setzt das Layout
     */
    private void setLayout() {

	contentPane = this.getContentPane();
	contentPane.setLayout(new GridLayout(6, 4));
    }

    /*
     * Diese Methode ermittelt das Zentrum des verwendeten Bildschirms
     * 
     * @Author Michael Kirsch
     * 
     * @param frame
     * 
     * @return Point mit zentraler Position
     */
    private Point getCenterPosition(JFrame frame) {

	Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
	Point p = new Point(((d.width - frame.getWidth()) / 2), ((d.height - frame.getHeight()) / 2));
	return p;
    }

    @Override
    /**
     * Übernimmt die Behandlung von Actionevents
     */
    public void actionPerformed(ActionEvent e) {

	for (int i = 0; i < buttons.length; i++) {
	    if (e.getSource() instanceof JButton) { // nur wenn Button gedrückt wurde
		JButton source = (JButton) e.getSource(); // Frage nach, wer das Event ausgelöst hat
		if (source == buttons[i]) { // Wenn von Button ausgeführt...
		    buttons[i].setEnabled(false); // Nicht mehr klickbar
		    if (source == buttons[5]) {
			JOptionPane.showMessageDialog(JOptionPane.getRootFrame(), "Heute kommt der Nikolaus! \nHo ho ho!");

		    } else if (source == buttons[23])
			JOptionPane.showMessageDialog(JOptionPane.getRootFrame(), "Heute ist Heiligabend!");

		    break; // Sobald ein Event behandelt wurde, beende Schleifendurchlauf
		}
	    }

	}

    }

}
